#!/bin/sh

CURR_USER=`logname`
CURR_DIR=`pwd`

cd /Library/Frameworks/
#tar -xvf Sentinel.tar
#rm -rf Sentinel.tar
#cd $CURR_DIR

CURR_SSD_VERSION=0752

SSD_VERSION=0752.00

SNTL_COMM_PATH=/Applications/Safenet\ Sentinel/
#FRMWRK_INST_PATH=/Library/Frameworks
DRIVER_INST_PATH=/System/Library/Extensions
UPRO_SRVR_PATH=/Applications/Sentinel

UPRO_DRIVER_PATH="/Library/Receipts/SentinelSystemDriver.pkg"
UPRO_FRMWRK_PATH="/Library/Receipts/SentinelFramework.pkg"


sudo chmod -R 775 "$SNTL_COMM_PATH"

sudo chown -R "$CURR_USER" "$SNTL_COMM_PATH"
sudo chown -R root:wheel "$DRIVER_INST_PATH"/Sentinel.kext
sudo chmod -R 755 "$DRIVER_INST_PATH"/Sentinel.kext

## Stop the Sentinel Keys Server if it is already running
sudo sh /Applications/Safenet\ Sentinel/Common\ Files/Sentinel\ Keys\ Server/loadserv.sh stop

sudo kextload /System/Library/Extensions/Sentinel.kext

### Instance count

[ -f "/Library/Receipts/SafenetSentinelProduct.Info" ]
if [ $? -ne 0 ]
then
    echo "SentinelSystemDriver="$SSD_VERSION":Count=0"  >> /Library/Receipts/SafenetSentinelProduct.Info
else
   ssd=`grep -c SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 1`
   if [ $ssd = 0 ]
   then 
     echo "SentinelSystemDriver="$SSD_VERSION":Count=0"  >> /Library/Receipts/SafenetSentinelProduct.Info
   fi   
fi


ssd_version=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1`
if [ $ssd_version = $SSD_VERSION ] 
then  
	current_inst=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 3`
    	increment_inst=1
    	count_SSD=`expr $current_inst + $increment_inst`

    	sudo echo "/SentinelSystemDriver/" > /tmp/SNTLCMD
    	sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
   	(sudo grep "SentinelSystemDriver" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1

   	echo "SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD  >>  /Library/Receipts/SafenetSentinelProduct.Info
   	rm -rf /tmp/SNTLCMD
fi

###If previous version of SSP is installed
ssd_version=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1 | cut -d . -f 1`
if [ $ssd_version -lt $CURR_SSD_VERSION ] 
then    
    current_inst=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 3`
    increment_inst=1
    count_SSD=`expr $current_inst + $increment_inst`

   sudo echo "/SentinelSystemDriver/" > /tmp/SNTLCMD
   sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
   (sudo grep "SentinelSystemDriver" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1

   echo "SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD  >>  /Library/Receipts/SafenetSentinelProduct.Info
   rm -rf /tmp/SNTLCMD

   ### Start Sentinel Server after upgrade
   sudo sh /Applications/Safenet\ Sentinel/Common\ Files/Sentinel\ Keys\ Server/loadserv.sh start
   sudo kextload /System/Library/Extensions/Sentinel.kext
fi


sudo chmod 775 /Library/Receipts/SafenetSentinelProduct.Info
